<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/parteleser.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>parteleser.c</h1><a href="parteleser_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: parteleser.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a><a class="code" href="parteleser_8c.html#ae33fb5e4bf8cbe9e2361e84f29a77d35">00027</a> <span class="preprocessor">#define PREALLOC_DG 25</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#ifdef METIS</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>EXTERN_C_BEGIN
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;metis.h&quot;</span>
<a name="l00035"></a>00035 EXTERN_C_END
<a name="l00036"></a>00036 <span class="preprocessor">#endif</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>
<a name="l00038"></a><a class="code" href="parteleser_8c.html#a338625e08e016cbad07c3c6bd5159822">00038</a> <span class="keywordtype">int</span> <a class="code" href="parteleser_8c.html#a338625e08e016cbad07c3c6bd5159822">MetisPartition</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,<span class="keywordtype">int</span> parts)
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="keywordtype">int</span> rank,size;
<a name="l00043"></a>00043   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00044"></a>00044   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="keywordflow">if</span> (rank) {
<a name="l00047"></a>00047     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00048"></a>00048   }
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00051"></a>00051     <span class="stringliteral">&quot;Meshpartitioning using METIS for %i processors\n&quot;</span>,
<a name="l00052"></a>00052     parts
<a name="l00053"></a>00053   );
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="preprocessor">#ifdef METIS</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>  <span class="comment">/* directly use METIS_PartGraphKWay, since we do already have ia and ja.</span>
<a name="l00057"></a>00057 <span class="comment">     Now we do it twice, but it does not make much difference since Metis is</span>
<a name="l00058"></a>00058 <span class="comment">     so fast.</span>
<a name="l00059"></a>00059 <span class="comment">  */</span>
<a name="l00060"></a>00060 <span class="comment">/* partition elements</span>
<a name="l00061"></a>00061 <span class="comment">    METIS_PartMeshDual(</span>
<a name="l00062"></a>00062 <span class="comment">*/</span>
<a name="l00063"></a>00063 <span class="comment">/* partition nodes */</span>
<a name="l00064"></a>00064   <span class="keywordtype">int</span> t_edgecut;
<a name="l00065"></a>00065   <span class="keywordtype">int</span> zero=0,two=2;
<a name="l00066"></a>00066   METIS_PartMeshNodal(
<a name="l00067"></a>00067     &amp;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,
<a name="l00068"></a>00068     &amp;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,
<a name="l00069"></a>00069     gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,
<a name="l00070"></a>00070     &amp;two,
<a name="l00071"></a>00071     &amp;zero,
<a name="l00072"></a>00072     &amp;parts,
<a name="l00073"></a>00073     &amp;t_edgecut,
<a name="l00074"></a>00074     gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>,
<a name="l00075"></a>00075     gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>
<a name="l00076"></a>00076   );
<a name="l00077"></a>00077 <span class="preprocessor">#else</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>  SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;Metis library not linked in, but it is required for volume mesh partitioning.\n&quot;</span>);
<a name="l00079"></a>00079 <span class="preprocessor">#endif</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span>
<a name="l00081"></a>00081   <span class="comment">/* create trivial local-&gt;global mappings */</span>
<a name="l00082"></a>00082   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; i++) {
<a name="l00083"></a>00083     gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]=i;
<a name="l00084"></a>00084   }
<a name="l00085"></a>00085   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>; i++) {
<a name="l00086"></a>00086     gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>[i]=i;
<a name="l00087"></a>00087   }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">/* Create a global reordering (mapping) of the vertices and elements</span>
<a name="l00090"></a>00090 <span class="comment">     by permuting the trivial mapping</span>
<a name="l00091"></a>00091 <span class="comment">  */</span>
<a name="l00092"></a>00092   <a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,1,gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>,parts,0);
<a name="l00093"></a>00093   <a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,1,gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>,parts,0);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00096"></a>00096 }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="comment">/*</span>
<a name="l00099"></a>00099 <span class="comment">   Given the grid data, determines a new partitioning of</span>
<a name="l00100"></a>00100 <span class="comment">   the CELLS (elements) to reduce the number of cut edges between</span>
<a name="l00101"></a>00101 <span class="comment">   cells (elements).</span>
<a name="l00102"></a>00102 <span class="comment">*/</span>
<a name="l00103"></a>00103 
<a name="l00104"></a><a class="code" href="parteleser_8c.html#a6458904885e6dd97ed495c8ad5f11ca0">00104</a> <span class="keywordtype">int</span> <a class="code" href="init_8h.html#a6458904885e6dd97ed495c8ad5f11ca0">DataPartitionElementsSer</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00105"></a>00105 {
<a name="l00106"></a>00106   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="keywordtype">int</span> rank,size;
<a name="l00109"></a>00109   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00110"></a>00110   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="keywordflow">if</span> (rank) {
<a name="l00113"></a>00113     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00114"></a>00114   }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   PetscTruth flg;
<a name="l00117"></a>00117   <span class="keywordtype">int</span> dometispartition;
<a name="l00118"></a>00118   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-metispartition&quot;</span>,&amp;dometispartition,&amp;flg);CHKERRQ(ierr);
<a name="l00119"></a>00119   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00120"></a>00120     dometispartition=0;
<a name="l00121"></a>00121     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00122"></a>00122       <span class="stringliteral">&quot;Option -metispartition not found, using default value %i\n&quot;</span>,
<a name="l00123"></a>00123       dometispartition
<a name="l00124"></a>00124     );
<a name="l00125"></a>00125   }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="keywordflow">if</span> (dometispartition&lt;0) {
<a name="l00128"></a>00128     SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;-metispartition invalid! Exiting!\n&quot;</span>);
<a name="l00129"></a>00129   }
<a name="l00130"></a>00130   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (dometispartition==0) {
<a name="l00131"></a>00131     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;METIS not used for mesh partitioning.\n&quot;</span>);
<a name="l00132"></a>00132     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00133"></a>00133   }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="keywordflow">if</span> (dometispartition==1) {
<a name="l00136"></a>00136     dometispartition=size;
<a name="l00137"></a>00137   }
<a name="l00138"></a>00138   <span class="keywordflow">if</span> (dometispartition==1) {
<a name="l00139"></a>00139     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Mesh partitioning not performed since not necessary on one processor.\n&quot;</span>);
<a name="l00140"></a>00140     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00141"></a>00141   }
<a name="l00142"></a>00142   <span class="keywordflow">if</span> (dometispartition&lt;size) {
<a name="l00143"></a>00143     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%i partitions for %i processors: some processors unused!\n&quot;</span>,dometispartition,size);
<a name="l00144"></a>00144   }
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   ierr = <a class="code" href="parteleser_8c.html#a338625e08e016cbad07c3c6bd5159822">MetisPartition</a>(gdata,dometispartition);CHKERRQ(ierr);
<a name="l00147"></a>00147   ierr = <a class="code" href="init_8h.html#a6924d6317e2e503ad009880947d9f905">CheckPartition</a>(gdata,dometispartition);CHKERRQ(ierr);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="comment">/* remap to real number of processors */</span>
<a name="l00150"></a>00150 
<a name="l00151"></a>00151   <span class="keywordflow">if</span> (dometispartition&gt;size) {
<a name="l00152"></a>00152     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00153"></a>00153       <span class="stringliteral">&quot;Remapping %i partitions onto %i processors.\n&quot;</span>,
<a name="l00154"></a>00154       dometispartition,size
<a name="l00155"></a>00155     );
<a name="l00156"></a>00156     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00157"></a>00157       gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>[i]= <a class="code" href="distint_8c.html#a42616e8c2899205c9fb1890cf0fb1e7b">distint</a>(dometispartition,size,gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>[i]);
<a name="l00158"></a>00158     }
<a name="l00159"></a>00159     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;i++) {
<a name="l00160"></a>00160       gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>[i]=<a class="code" href="distint_8c.html#a42616e8c2899205c9fb1890cf0fb1e7b">distint</a>(dometispartition,size,gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>[i]);
<a name="l00161"></a>00161     }
<a name="l00162"></a>00162   }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   <span class="comment">/* Permute data according to new numbering */</span>
<a name="l00165"></a>00165   IS isvert,isele;
<a name="l00166"></a>00166   ierr = ISCreateGeneral(PETSC_COMM_SELF,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>,&amp;isvert);CHKERRQ(ierr);
<a name="l00167"></a>00167   ierr = ISSetPermutation(isvert);CHKERRQ(ierr);
<a name="l00168"></a>00168   ierr = ISCreateGeneral(PETSC_COMM_SELF,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>,&amp;isele);CHKERRQ(ierr);
<a name="l00169"></a>00169   ierr = ISSetPermutation(isele);CHKERRQ(ierr);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   <span class="comment">/* CheckPartition done above */</span>
<a name="l00172"></a>00172   ierr = <a class="code" href="init_8h.html#a325dee9c88a63835d07e633aac72bc7e">PermuteData</a>(gdata,isvert,isele);CHKERRQ(ierr);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   ierr = ISDestroy(isvert);CHKERRQ(ierr);
<a name="l00175"></a>00175   ierr = ISDestroy(isele);CHKERRQ(ierr);
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00178"></a>00178 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

